#!/bin/sh

. ../cgi-bin/common/ajax_common

MD5="/usr/ramdisk/bin/md5"
WEBLOGIN="/usr/ramdisk/tmp/weblogin"

PALANG="ch"
PALANGCONF="${PGETC}/palang.conf"
SYSNAMECONF="${PGETC}/sysname.conf"
WEBACL="${PGETC}/App/systemgd/webacl.conf"
Auth_type_file="${PGETC}/App/opser/auth_type.conf"

pswdLeft=0

[ -f ${PALANGCONF} ] && . ${PALANGCONF}
[ -f ${Auth_type_file} ] && . ${Auth_type_file}
[ -f ${PGETC}/ifadmin.conf ] && . ${PGETC}/ifadmin.conf
[ -f ${WEBACL} ] && . ${WEBACL}


logPageConf()
{
	SYSNAME=""

	[ -f ${SYSNAMECONF} ] && . ${SYSNAMECONF}
	[ "${NTM}" = "1" ] && JOS_RELEASE=4
	[ "${JOS_RELEASE}" != "1" -a "${JOS_RELEASE}" != "5" ] && CHONLY=1
	[ "${ENONLY}" = "" ] && ENONLY=0
	blockTime=`verify_errnum get`
	
	printf "{"
	printf "\"lang\":\"${PALANG}\","
	printf "\"enonly\":\"${ENONLY}\","
	printf "\"chonly\":\"${CHONLY}\","
	printf "\"title\":\"${SYSNAME}\","
	printf "\"verifyCode\":\"${verifyCode}\","
	printf "\"maxErr\":\"${maxErr}\","
	printf "\"lockTime\":\"${lockTime}\","
	printf "\"blockTime\":\"${blockTime}\","
	printf "\"pswdTTL\":\"${pswdTTL}\","
	printf "\"auth_type\":\"${auth_type}\""
	printf "}"
}


record_errnum()
{
	[ "${maxErr}" = "0" ] && return

	mkdir -p ${WEBLOGIN}
	efile="${WEBLOGIN}/FAIL_${REMOTE_ADDR}"
	ERRNUM=1

	if [ -f ${efile} ]; then
		. ${efile}
		ERRNUM=$((${ERRNUM}+1))
	fi

	echo "ERRNUM=${ERRNUM}" > ${efile}
	echo "LEFT=`date +%s`" >> ${efile}

	if [ ${ERRNUM} -eq ${maxErr} ]; then
		LOG_MSG="¼¼"
		[ "${PALANG}" = "en" ] && LOG_MSG="LOGIN_BLOCK"
		WEB_LOGGER "${LOG_MSG}" "user=${CGI_username},ip=${REMOTE_ADDR}" "${CGI_username}"
	fi
}


verify_errnum()
{
	efile="${WEBLOGIN}/FAIL_${REMOTE_ADDR}"
	
	if [ "${maxErr}" = "0" ]; then
		[ -f "${efile}" ] && rm ${efile}
		return
	fi

	[ ! -f "${efile}" ] && return

	. ${efile}
	
	[ ${ERRNUM} -lt ${maxErr} ] && return

	now=`date +%s`
	free=$((${now}-${LEFT}))
	if [ ${free} -lt ${lockTime} ]; then
		if [ "${1}" = "get" ]; then
			echo $((${lockTime}-${free}))
		else
			retjson 1 "LOGIN_BLOCK" $((${lockTime}-${free}))
		fi
	else
		rm ${efile}
	fi
}


cookie_make()
{
	logintime=`date +%s1`
	code=`uuidgen | cut -c5-8`
	md5_code=`${MD5} ${code}`
	echo "paonline_${CGI_username}_$$_${logintime}_${md5_code}|${SERVER_PORT}|"
}


codemake()
{
	mkdir -p ${WEBLOGIN}
	code=`uuidgen | cut -c5-8`
	cfile="${WEBLOGIN}/CODE_${REMOTE_ADDR}"
	echo "CODE=${code}" > ${cfile}
	echo "LIVE=`date +%s`" >> ${cfile}
}


codepost()
{
	cfile="${WEBLOGIN}/CODE_${REMOTE_ADDR}"
	
	[ ! -f ${cfile} ] && codemake

	. ${cfile}
	
	retjson 0 "OK" "\"${CODE}\""
}


codecmp()
{
	cfile="${WEBLOGIN}/CODE_${REMOTE_ADDR}"

	[ ! -f ${cfile} ] && return
	
	if [ "${CGI_code}" = "" ]; then
		codemake
		retjson 1 "Code_Error"
	fi

	. ${cfile}
	
	now=`date +%s`
	
	if [ $((${now} - ${LIVE})) -gt 60 ]; then
		codemake
		retjson 1 "Code_TIMEOUT"
	fi

	if [ "${CGI_code}" != "${CODE}" ]; then
		codemake
		retjson 1 "Code_Error"
	fi

	[ -f ${cfile} ] && rm -f ${cfile}
}


radius_auth()
{
	RADCLIENT=/usr/ramdisk/app/opser/bin/radclient

	if [ ! -x ${RADCLIENT} ]; then
		CGI_password=`${MD5} ${CGI_password}`
		local_auth
		return
	fi
	
	if [ "${raas_url}" != "" ]; then
		CGI_username="${CGI_username}@${raas_url}"
	fi
	
	${RADCLIENT} -u ${CGI_username} -p ${CGI_password} -r ${rad_ip} -i ${ADMIN_IP} -n ${nas_id} -s ${rad_key} -f ${REMOTE_ADDR} -t ${rad_timeout}
}


local_auth()
{
	if [ ! -f ${PGPATH}/admin/.htpasswd ]; then
		echo "Auth_Fail"
		return
	fi

	for line in `cat ${PGPATH}/admin/.htpasswd`
	do
		name=`echo ${line} | cut -d':' -f1`
		if [ "${name}" = "${CGI_username}" ]; then
			pwd=`echo ${line} | cut -d':' -f2`
			md5pwd=`${MD5} ${pwd}`
			pwCday=`echo ${line} | cut -d":" -f3`
			[ "${pwCday}" = "" ] && pwCday=`date +%s`

			[ "${pswdTTL}" = "" ] && pswdTTL=0
			if [ "${pswdTTL}" != "0" ]; then
				_ttl=$((${pswdTTL} - (`date +%s`- ${pwCday})))
				if [  ${_ttl} -le 0 ]; then
					echo "PSWD_TIMEOUT"
					return
				else
					pswdLeft=$((${_ttl} / 24 /60 / 60))
				fi
			fi

			if [ "${md5pwd}" = "${CGI_password}" ]; then
				echo "AUTH_OK|${pswdLeft}"
				return
			fi
		fi
	done

	echo "Auth_Fail"
}


user_login()
{
	if [ "${PALANG}" = "en" ]; then
		NAME_MSG="INV_NAME"
	fi

	# check allow ip list
	if [ -f /etc/pawebhosts ]; then
		exist=`grep -R "^${REMOTE_ADDR}$" /etc/pawebhosts`
		if [ "${exist}" = "" ]; then
			codemake
			retjson 1 "IPDENY"
		fi
	fi

	[ "${CGI_username}" = "" ] && retjson 1 "${NAME_MSG:=Чû}"
	xss=`echo ${CGI_username} | grep -E "[<*.&/>]"`
	[ "${xss}" != "" ] && retjson 1 "${NAME_MSG:=Чû}"

	verify_errnum
	codecmp

	# local or radius
	if [ "${auth_type}" = "radius" ]; then
		auth_ret=`radius_auth`
	elif [ "${auth_type}" = "rad_then_local" ]; then
		auth_ret=`radius_auth`
		if [ "${auth_ret}" = "TIME_OUT" ]; then
			CGI_password=`${MD5} ${CGI_password}`
			auth_ret=`local_auth`
		fi
	else
		auth_ret=`local_auth`
	fi

	pswdLeft=`echo "${auth_ret}" | cut -d"|" -f2`
	auth_ret=`echo "${auth_ret}" | cut -d"|" -f1`
	[ "${pswdLeft}" = "" ] && pswdLeft=0

	# Login Fail
	if [ "${auth_ret}" != "AUTH_OK" ]; then
		codemake
		[ "${ERRNUM}" = "" ] && ERRNUM=0
		left_changce=$((${maxErr}-${ERRNUM}))
		
		record_errnum
		errmsg=`${FLOWEYE} logger alert "${CGI_username} login FAIL from ${REMOTE_ADDR}"`
		retjson 1 "${auth_ret}" ${left_changce}
	fi

	# Login Success
	mkdir -p /usr/ramdisk/weblogin/
	echo "PALANG=${CGI_palang}" > ${PALANGCONF}

	ckinfo=`cookie_make`
	ckfile="/usr/ramdisk/weblogin/${ckinfo}"

	echo "ip=${REMOTE_ADDR}" > ${ckfile}
	echo "user=${CGI_username}" >> ${ckfile}
	echo "logintime=`date +%Y.%m.%d/%H:%M:%S`" >> ${ckfile}

	LOG_MSG="û¼"
	[ "${PALANG}" = "en" ] && LOG_MSG="USER_LOGIN"
	WEB_LOGGER "${LOG_MSG}" "user=${CGI_username},ip=${REMOTE_ADDR}" "${CGI_username}"
	errmsg=`${FLOWEYE} logger alert "${CGI_username} login success from ${REMOTE_ADDR}"`
	[ -f "${efile}" ] && rm "${efile}"
	
	printf "Content-Type:application/json;charset=gb2312\r\n"
	printf "Set-Cookie: ${PANABIT_CKNAME}=${ckinfo};Secure=true;Path=/;HTTPOnly\r\n"
	printf "\r\n"

	echo -n "{ \"code\": 0, \"msg\": \"Auth_OK\", \"pwleft\": \"${pswdLeft}\"}"

	exit 0
}


# action from login.htm
case "${CGI_action}" in
	"logPageConf")
		print_json_head
		logPageConf
		exit 0
		;;

	"getauthcode")
		codemake
		codepost
		;;
	
	"user_login")
		user_login
		;;
esac


# Login From Cloud or Get userverify.cgi
printf "Content-type: text/html\r\n";
printf "Cache-Control: no-cache\r\n"

if [ "${CGI_pakey}" != "" -a "${CGI_username}" = "admin" ]; then
	keyexist=`${FLOWEYE} cloud list | grep "${CGI_pakey}"`
	if [ "${keyexist}" = "" ]; then
		printf "\r\n"
		echo "<html xmlns:v=\"urn:schemas-microsoft-com:vml\" xmlns:o=\"urn:schemas-microsoft-com:office:office\">"
		echo "<head>"
		echo "<script language=javascript>"
		echo "alert(\"!\");"
		echo "</script>"
		echo "<meta http-equiv=\"Content-Type\" content=\"text/html; charset=gb2312\">"
		echo "<META HTTP-EQUIV=REFRESH CONTENT=\"0;URL=/login/login.htm\">"
		echo "</head>"
		echo "</html>"

		exit 0
	else
		mkdir -p /usr/ramdisk/weblogin/
		ckinfo=`cookie_make`
		ckfile="/usr/ramdisk/weblogin/${ckinfo}"
	
		errmsg=`${FLOWEYE} cloud remove key=${CGI_pakey}`
		echo "ip=${REMOTE_ADDR}" > ${ckfile}
		echo "user=${CGI_username}" >> ${ckfile}
		echo "logintime=`date +%Y.%m.%d/%H:%M:%S`" >> ${ckfile}

		printf "Set-Cookie: ${PANABIT_CKNAME}=${ckinfo};Path=/;HTTPOnly;palang=${PALANG}\r\n"
		printf "\r\n"

		echo "<html xmlns:v=\"urn:schemas-microsoft-com:vml\" xmlns:o=\"urn:schemas-microsoft-com:office:office\">"
		echo "<head>"
		echo "<meta http-equiv=\"Content-Type\" content=\"text/html; charset=gb2312\">"
		echo "<META HTTP-EQUIV=REFRESH CONTENT=\"0;URL=/\">"
		echo "</head>"
		echo "</html>"

		exit 0
	fi
fi

printf "\r\n"
echo "<html xmlns:v=\"urn:schemas-microsoft-com:vml\" xmlns:o=\"urn:schemas-microsoft-com:office:office\">"
echo "<head>"
echo "<meta http-equiv=\"Content-Type\" content=\"text/html; charset=gb2312\">"
echo "<META HTTP-EQUIV=REFRESH CONTENT=\"0;URL=/login/login.htm\">"
echo "</head>"
echo "</html>"
	